'*************************************************************
'*** WARNING *** COLORS MAY NOT PRINT EXACTLY AS ON SCREEN ***
'*** WARNING *** MAY PRINT GRAYSCALE ON SOME SYSTEMS *********
'*************************************************************
'Demo that prints screen to printer
'and gets number of copies chosen by user.
'It will print the number of copies chosen
'in a for... next loop.

nomainwin

WindowWidth=300:WindowHeight=320
open "Graphic Print Test" for graphics_nsb as #1
    print #1, "trapclose [quit]"
    h=hwnd(#1)
    print #1, "down;color pink;backcolor yellow;size 10"
    print #1, "place 100 100;circlefilled 50"
    print #1, "color darkred"
    print #1, "line 10 10 90 120"
    print #1, "flush"


[setup.values]
    xorg=0     'in screen pixels
    yorg=0     'copy graphic from here
    width=200
    height=200

    pxorg=100    'in hundredths of inch
    pyorg=200    'print graphic on page here
    pwidth=300
    pheight=300

[print]
    cursor hourglass
    open "lbprnt01.dll" for dll as #lb
    gosub [create.printer.dc]

    if pDC=0 THEN
        notice "Print is cancelled!"
        goto [quit]
        END
    end if

    gosub [get.number.copies]
    notice "Number of copies chosen was "+str$(numbercopies)

    for i = 1 to numbercopies        'print graphic in chosen number of copies
        if i>1 then gosub [new.page] 'eject page and start a new one
        gosub [print.screen]
    next i

    gosub [end.print]
    cursor normal
    goto [loop]

[loop]
input avar$

[quit]
    cursor normal
    close #lb
    close #1
    END


[create.printer.dc]
    CallDll #lb, "PrinterDialog",_  'must call this to start a document
        h as short,_                'handle of program window
        pDC as short                'nozero if successful
    RETURN


[get.number.copies]
    CallDll #lb, "GetNumberCopies",_ 'only works with PrinterDialog call
        h as short,_                 'window handle
        numbercopies as short        'number of copies chosen by user
        RETURN


[end.print] 'must call at end of job
    CallDll #lb, "EndPrint",_   'ends document
        h as short,_            'window handle
        r as short              'nonzero if successful

    RETURN



[print.screen]
    CallDll #lb, "PrintWindowArea",_'MAY PRINT IN GRAYSCALE
        h as short,_        'window handle
        xorg as short,_     'starting x for print
        yorg as short,_     'starting y for print
        width as short,_    'width from screen
        height as short,_   'height from screen
        pxorg as short,_    'x loc on page in hundredths of inch
        pyorg as short,_    'y loc on page in hundredths of inch
        pwidth as short,_   'width of image on page
        pheight as short,_  'height of image on page
        r as short

    RETURN


[new.page]
    CallDll #lb, "NewPage",_    'ejects page, starts new one
        h as short,_            'window handle
        r as short              'nonzero if sucessful
    return
